/***************************************************************************
 * COPYRIGHT NOTICE:
 * 
 * Bu projenin kaynak kodlarn size atysam bu aadaki bilgileri
 * deitirebileceiniz anlamna gelmiyor.
 *  
 * Ltfen, emee sayg duyuyorsanz bu dosyaya hi bir ekilde mdahele
 * etmeyin. Yarn bir gn siz de benim gibi byle projeler gelitirip
 * bakasnn sizin yaptnz projeye adn yazmasna nasl katlanamazsanz
 * ayn ekilde ben de katlanamyorum.
 * 
 * UNUTMAYIN: Drstlk kiinin kendisinde balar.
 *  
 ***************************************************************************/

namespace Erle.Controls
{
	using System;
	using System.Collections;
	using System.Drawing;
	using System.Drawing.Imaging;
	using System.Drawing.Drawing2D;
	
	public class PictureGenerator
	{
		internal const string KeySecretCode = "Erle.Controls.KeySecretCode";
		internal static readonly Random rand = new Random();

		private static readonly Color[] colors = new Color[]
		{
			Color.Wheat, Color.LightSkyBlue, Color.SkyBlue, Color.LightCyan,
			Color.PaleGreen, Color.Khaki, Color.Plum, Color.Honeydew, Color.Ivory,
			Color.PapayaWhip, Color.Bisque
		};
		
		private PictureGenerator() {}
		
		public static void Generate(System.Web.UI.Page page)
		{
			page.Response.Clear();
			page.Response.ContentType = "image/jpeg";
			String key = page.Session[KeySecretCode] as String;
			if (key == null || key.Length == 0)
			{
				CreateInvalidImage(page);
				return;
			}

			int total = key.Length;
			int w = 70, h = 20;
			try
			{
				w = Convert.ToInt32(page.Request.Params["w"]);
				if (w <= 70) w = 70;
				if (w >= 210) w = 210;
			}
			catch {	w = 70;}
			try
			{
				h = Convert.ToInt32(page.Request.Params["h"]);
				if (h <= 20) h = 20;
				if (h >= 60) h = 60;
			}
			catch {	h = 20; }

			int ds = (w-10)/total;
			if (ds > (h-10)) ds = h-10;

			using(Bitmap bitmap = new Bitmap(w, h, PixelFormat.Format24bppRgb))
			{
				using(Graphics g = Graphics.FromImage(bitmap))
				{
					StringFormat sf = new StringFormat();
					sf.Alignment = StringAlignment.Center;
					g.SmoothingMode = SmoothingMode.AntiAlias;
					g.Clear( colors[rand.Next(colors.Length)] );
					g.DrawString(
						key,
						new Font("Tahoma", ds, FontStyle.Bold),
						SystemBrushes.WindowText,
						new Point(rand.Next(0, w-(ds*total)), rand.Next(0, (h-ds)/2))
					);
					bitmap.Save(page.Response.OutputStream, ImageFormat.Jpeg);
				}
			}
			page.Response.End();
		}

		private static void CreateInvalidImage(System.Web.UI.Page page)
		{
			using(Bitmap bitmap = new Bitmap(80, 20, PixelFormat.Format24bppRgb))
			{
				using(Graphics g = Graphics.FromImage(bitmap))
				{
					StringFormat sf = new StringFormat();
					sf.Alignment = StringAlignment.Center;
					g.SmoothingMode = SmoothingMode.AntiAlias;
					g.Clear( colors[rand.Next(colors.Length)] );
					g.DrawString(
						"invalid session",
						new Font("Tahoma", 8, FontStyle.Regular),
						SystemBrushes.WindowText,
						new Point(4, 3)
					);
					bitmap.Save(page.Response.OutputStream, ImageFormat.Jpeg);
				}
			}
			page.Response.End();
		}
	}
};
