/***************************************************************************
 * COPYRIGHT NOTICE:
 * 
 * Bu projenin kaynak kodlarn size atysam bu aadaki bilgileri
 * deitirebileceiniz anlamna gelmiyor.
 *  
 * Ltfen, emee sayg duyuyorsanz bu dosyaya hi bir ekilde mdahele
 * etmeyin. Yarn bir gn siz de benim gibi byle projeler gelitirip
 * bakasnn sizin yaptnz projeye adn yazmasna nasl katlanamazsanz
 * ayn ekilde ben de katlanamyorum.
 * 
 * UNUTMAYIN: Drstlk kiinin kendisinde balar.
 *  
 ***************************************************************************/

namespace Erle.Controls
{
	using System;
	using System.Web.UI;

	public class RegistrationImage : Control
	{
		private int d = 4, w = 70, h = 20;
		private string url = "RegistrationImage.aspx";

		public RegistrationImage() : base() {}
		
		public String ImageUrl 
		{
			get { return url; }
			set { url = value; }
		}

		public int Width
		{
			get { return w; }
			set 
			{ 
				w = value <= 70 ? 70 : value;
				if (w >= 210) w = 210;
			}
		}

		public int Height
		{
			get { return h; }
			set 
			{ 
				h = value <= 20 ? 20 : value;
				if (h >= 60) h = 60;
			}
		}

		public int Digits
		{
			get { return d; }
			set 
			{ 
				if (value <= 4) d = 4;
				else if (value >= 20) d = 20;
				else d = value;
			}
		}

		private String code 
		{
			get { return Page.Session[PictureGenerator.KeySecretCode] as String; }
			set { Page.Session[PictureGenerator.KeySecretCode] = value; }
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);
			if ((!Page.IsPostBack) || (code == null))
			{
				String str = String.Empty;
				for(int i = 0; i < Digits; i++)
					str += PictureGenerator.rand.Next(1, 10);

				code = str;
			}
		}

		protected override void Render(HtmlTextWriter output)
		{
			base.Render(output);
			const string url = "<img border=1 src=\"{0}?w={1}&h={2}\" alt=\"SecretCode\">";
			output.Write(String.Format(url, ImageUrl, Width, Height));
		}
	}
};
